//
// Created by michal on 7.4.18.
//

#pragma once

#ifdef __cplusplus
extern "C" {
#endif


#define SPI_DEVICE_CHECK(DEVICE)               (((DEVICE) == SPI_DEVICE_1)    || \
                                                ((DEVICE) == SPI_DEVICE_HSPI) || \
                                                ((DEVICE) == SPI_DEVICE_VSPI))

#define SPI_CLOCK_MODE_CHECK(CLOCK_MODE)       (((CLOCK_MODE) == SPI_CLOCK_MODE_0) || \
                                                ((CLOCK_MODE) == SPI_CLOCK_MODE_1) || \
                                                ((CLOCK_MODE) == SPI_CLOCK_MODE_2) || \
                                                ((CLOCK_MODE) == SPI_CLOCK_MODE_3))

#define SPI_BIT_ORDER_CHECK(BIT_ORDER)         (((BIT_ORDER) == SPI_BIT_ORDER_MSB_FIRST) || \
                                                ((BIT_ORDER) == SPI_BIT_ORDER_LSB_FIRST))


typedef enum
{
    SPI_CLOCK_MODE_0 = 0,
    SPI_CLOCK_MODE_1,
    SPI_CLOCK_MODE_2,
    SPI_CLOCK_MODE_3
} SPI_Clock_Mode_t;

typedef enum
{
    SPI_BIT_ORDER_MSB_FIRST,
    SPI_BIT_ORDER_LSB_FIRST
} SPI_Bit_Order_t;

typedef enum
{
    SPI_DEVICE_1 = 1,
    SPI_DEVICE_HSPI,
    SPI_DEVICE_VSPI
} SPI_Device_t;

// assuming ESP-IDF never uses DMA in SPI flash driver - it should be true
// helper function, should not be called directly
esp_err_t SPI_DMA_Channel_Try_Acquire(SPI_Device_t device);

// helper function, should not be called directly
void SPI_DMA_Channel_Free(SPI_Device_t device);

#ifdef __cplusplus
}
#endif
